searchData={"items":[{"type":"module","title":"Cucumber","doc":"A behavior-driven development (BDD) testing framework for Elixir using Gherkin syntax.\n\nCucumber is a testing framework that allows you to write executable specifications\nin natural language. It bridges the gap between technical and non-technical stakeholders\nby allowing tests to be written in plain language while being executed as code.","ref":"Cucumber.html"},{"type":"module","title":"Setup - Cucumber","doc":"Add to your `test_helper.exs`:\n\n    Cucumber.compile_features!()","ref":"Cucumber.html#module-setup"},{"type":"module","title":"File Structure - Cucumber","doc":"By default, Cucumber expects the following structure:\n\n    test/\n      features/\n        authentication.feature\n        shopping.feature\n        step_definitions/\n          authentication_steps.exs\n          shopping_steps.exs\n          common_steps.exs\n        support/\n          hooks.exs","ref":"Cucumber.html#module-file-structure"},{"type":"module","title":"Configuration - Cucumber","doc":"You can customize paths in `config/test.exs`:\n\n    config :cucumber,\n      features: [\"test/features/**/*.feature\"],\n      steps: [\"test/features/step_definitions/**/*.exs\"]","ref":"Cucumber.html#module-configuration"},{"type":"module","title":"Step Definitions - Cucumber","doc":"Create step definition modules using `Cucumber.StepDefinition`:\n\n    defmodule AuthenticationSteps do\n      use Cucumber.StepDefinition\n      \n      step \"I am logged in as {string}\", %{args: [username]} = context do\n        {:ok, Map.put(context, :current_user, username)}\n      end\n    end","ref":"Cucumber.html#module-step-definitions"},{"type":"module","title":"Running Tests - Cucumber","doc":"Cucumber tests run with `mix test` and can be filtered using tags:\n\n    # Run all tests including Cucumber\n    mix test\n    \n    # Run only Cucumber tests\n    mix test --only cucumber\n    \n    # Exclude Cucumber tests\n    mix test --exclude cucumber","ref":"Cucumber.html#module-running-tests"},{"type":"module","title":"Key Features - Cucumber","doc":"* Auto-discovery of features and step definitions\n* Integration with ExUnit's tagging system\n* Context passing between steps\n* Support for data tables and doc strings\n* Rich error reporting with suggestions","ref":"Cucumber.html#module-key-features"},{"type":"function","title":"Cucumber.compile_features!/1","doc":"Discovers and compiles all cucumber features into ExUnit tests.\n\nThis function should be called in your `test_helper.exs` file.","ref":"Cucumber.html#compile_features!/1"},{"type":"function","title":"Options - Cucumber.compile_features!/1","doc":"* `:features` - List of patterns for feature files\n  * `:steps` - List of patterns for step definition files  \n  * `:support` - List of patterns for support files","ref":"Cucumber.html#compile_features!/1-options"},{"type":"function","title":"Examples - Cucumber.compile_features!/1","doc":"# Use default paths\n    Cucumber.compile_features!()\n    \n    # Use custom paths\n    Cucumber.compile_features!(\n      features: [\"test/acceptance/**/*.feature\"],\n      steps: [\"test/acceptance/steps/**/*.exs\"]\n    )","ref":"Cucumber.html#compile_features!/1-examples"},{"type":"module","title":"Cucumber.Compiler","doc":"Compiles discovered features and steps into ExUnit test modules.","ref":"Cucumber.Compiler.html"},{"type":"function","title":"Cucumber.Compiler.compile_features!/1","doc":"Compiles all discovered features into ExUnit test modules.","ref":"Cucumber.Compiler.html#compile_features!/1"},{"type":"module","title":"Cucumber.Discovery","doc":"Discovers and loads feature files and step definitions.","ref":"Cucumber.Discovery.html"},{"type":"function","title":"Cucumber.Discovery.discover/1","doc":"Discovers all features and steps based on configuration.\nReturns a struct containing parsed features and a registry of steps.","ref":"Cucumber.Discovery.html#discover/1"},{"type":"module","title":"Cucumber.Expression","doc":"Parser and matcher for Cucumber Expressions used in step definitions.\n\nCucumber Expressions are a human-friendly alternative to regular expressions,\nallowing you to define step patterns with typed parameters. This module handles\ncompiling these expressions to regular expressions and extracting/converting parameters.","ref":"Cucumber.Expression.html"},{"type":"module","title":"Parameter Types - Cucumber.Expression","doc":"The following parameter types are supported:\n\n* `{string}` - Matches quoted strings (\"example\") and converts to string\n* `{int}` - Matches integers (42) and converts to integer\n* `{float}` - Matches floating point numbers (3.14) and converts to float\n* `{word}` - Matches a single word (no whitespace) and converts to string","ref":"Cucumber.Expression.html#module-parameter-types"},{"type":"module","title":"Examples - Cucumber.Expression","doc":"# Matching a step with a string parameter\n    \"I click {string} button\" would match:\n    \"I click \"Submit\" button\"\n\n    # Matching a step with multiple parameters\n    \"I add {int} items to my {word} list\" would match:\n    \"I add 5 items to my shopping list\"","ref":"Cucumber.Expression.html#module-examples"},{"type":"function","title":"Cucumber.Expression.compile/1","doc":"Compiles a Cucumber Expression pattern into a regex and parameter converters.\n\nThis function transforms a human-readable pattern with typed parameters\ninto a regular expression for matching and a list of converter functions\nto transform the captured values to their appropriate types.","ref":"Cucumber.Expression.html#compile/1"},{"type":"function","title":"Parameters - Cucumber.Expression.compile/1","doc":"* `pattern` - A string containing a Cucumber Expression pattern","ref":"Cucumber.Expression.html#compile/1-parameters"},{"type":"function","title":"Returns - Cucumber.Expression.compile/1","doc":"Returns a tuple `{regex, converters}` where:\n* `regex` - A compiled regular expression for matching step text\n* `converters` - A list of functions to convert captured values to their appropriate types","ref":"Cucumber.Expression.html#compile/1-returns"},{"type":"function","title":"Examples - Cucumber.Expression.compile/1","doc":"iex> {regex, converters} = Cucumber.Expression.compile(\"I have {int} items\")\n    iex> Regex.match?(regex, \"I have 42 items\")\n    true","ref":"Cucumber.Expression.html#compile/1-examples"},{"type":"function","title":"Cucumber.Expression.match/2","doc":"Matches a step text against a compiled Cucumber Expression.\n\nThis function attempts to match step text against a compiled Cucumber Expression\nand extracts/converts any parameters if there's a match.","ref":"Cucumber.Expression.html#match/2"},{"type":"function","title":"Parameters - Cucumber.Expression.match/2","doc":"* `text` - The step text to match against the pattern\n* `{regex, converters}` - A compiled Cucumber Expression from `compile/1`","ref":"Cucumber.Expression.html#match/2-parameters"},{"type":"function","title":"Returns - Cucumber.Expression.match/2","doc":"Returns one of:\n* `{:match, args}` - If the text matches, where `args` is a list of converted parameter values\n* `:no_match` - If the text doesn't match the expression","ref":"Cucumber.Expression.html#match/2-returns"},{"type":"function","title":"Examples - Cucumber.Expression.match/2","doc":"iex> compiled = Cucumber.Expression.compile(\"I have {int} items\")\n    iex> Cucumber.Expression.match(\"I have 42 items\", compiled)\n    {:match, [42]}\n    iex> Cucumber.Expression.match(\"I have no items\", compiled)\n    :no_match","ref":"Cucumber.Expression.html#match/2-examples"},{"type":"module","title":"Cucumber.Runtime","doc":"Runtime execution of cucumber steps.","ref":"Cucumber.Runtime.html"},{"type":"function","title":"Cucumber.Runtime.execute_step/3","doc":"Executes a step with the given context and step registry.","ref":"Cucumber.Runtime.html#execute_step/3"},{"type":"module","title":"Cucumber.StepDefinition","doc":"Provides macros for defining cucumber step definitions.","ref":"Cucumber.StepDefinition.html"},{"type":"module","title":"Usage - Cucumber.StepDefinition","doc":"defmodule AuthenticationSteps do\n      use Cucumber.StepDefinition\n      \n      step \"I am logged in as {string}\", %{args: [username]} = context do\n        {:ok, Map.put(context, :current_user, username)}\n      end\n    end","ref":"Cucumber.StepDefinition.html#module-usage"},{"type":"macro","title":"Cucumber.StepDefinition.step/3","doc":"Defines a step implementation.","ref":"Cucumber.StepDefinition.html#step/3"},{"type":"module","title":"Gherkin.Background","doc":"Represents a Gherkin Background section.\n\nA Background contains steps that are run before each scenario in the feature.\nIt allows you to define common setup steps that apply to all scenarios.","ref":"Gherkin.Background.html"},{"type":"type","title":"Gherkin.Background.t/0","doc":"","ref":"Gherkin.Background.html#t:t/0"},{"type":"module","title":"Gherkin.Feature","doc":"Represents a parsed Gherkin feature file (minimal subset).\n\nA Feature is the top-level element in a Gherkin file, containing a name,\noptional description, optional background, and one or more scenarios.\nIt can also have tags that apply to all scenarios in the feature.","ref":"Gherkin.Feature.html"},{"type":"type","title":"Gherkin.Feature.t/0","doc":"","ref":"Gherkin.Feature.html#t:t/0"},{"type":"module","title":"Gherkin.Parser","doc":"Minimal Gherkin 6 parser (Feature, Background, Scenario, Step).\n\nThis module parses Gherkin feature files into Elixir structs, supporting:\n- Feature with name, description, and tags\n- Background with steps\n- Scenarios with steps and tags\n- Steps with keywords, text, docstrings, and datatables\n\nIt implements a subset of the Gherkin language focused on core BDD concepts.","ref":"Gherkin.Parser.html"},{"type":"function","title":"Gherkin.Parser.parse/1","doc":"Parses a Gherkin feature file from a string into structured data.\n\nThis function takes a string containing Gherkin syntax and parses it into a\nstructured `Gherkin.Feature` struct with its associated components.","ref":"Gherkin.Parser.html#parse/1"},{"type":"function","title":"Parameters - Gherkin.Parser.parse/1","doc":"* `gherkin_string` - A string containing Gherkin syntax","ref":"Gherkin.Parser.html#parse/1-parameters"},{"type":"function","title":"Returns - Gherkin.Parser.parse/1","doc":"Returns a `%Gherkin.Feature{}` struct containing:\n* `name` - The feature name\n* `description` - The feature description\n* `tags` - List of feature-level tags\n* `background` - Background steps (if present)\n* `scenarios` - List of scenarios","ref":"Gherkin.Parser.html#parse/1-returns"},{"type":"function","title":"Examples - Gherkin.Parser.parse/1","doc":"# Parse a string containing Gherkin syntax\n    Gherkin.Parser.parse(\"Feature: Shopping Cart\nScenario: Adding an item\")\n    # Returns %Gherkin.Feature{} struct with parsed data","ref":"Gherkin.Parser.html#parse/1-examples"},{"type":"module","title":"Gherkin.Scenario","doc":"Represents a Gherkin Scenario section.\n\nA Scenario is a concrete example that illustrates a business rule.\nIt consists of a name, a list of steps, and optional tags for filtering.","ref":"Gherkin.Scenario.html"},{"type":"type","title":"Gherkin.Scenario.t/0","doc":"","ref":"Gherkin.Scenario.html#t:t/0"},{"type":"module","title":"Gherkin.Step","doc":"Represents a Gherkin step (Given/When/Then/And/But/*).\n\nA Step is a single action or assertion in a scenario. It consists of:\n- keyword: The step type (Given, When, Then, And, But, or *)\n- text: The step text that matches step definitions\n- docstring: Optional multi-line text block (triple-quoted)\n- datatable: Optional table data (pipe-delimited)\n- line: Line number in the source file","ref":"Gherkin.Step.html"},{"type":"type","title":"Gherkin.Step.t/0","doc":"","ref":"Gherkin.Step.html#t:t/0"},{"type":"exception","title":"Cucumber.StepError","doc":"Exception raised when a step in a Cucumber scenario fails.\n\nThis module provides detailed error reporting for two main failure cases:\n\n1. A step has no matching step definition\n2. A step's implementation raises an error or returns `{:error, reason}`\n\nThe error messages include helpful context like:\n- The failing step text and location\n- The scenario name and feature file\n- A history of previously executed steps\n- Suggestions for implementing missing steps","ref":"Cucumber.StepError.html"},{"type":"function","title":"Cucumber.StepError.failed_step/6","doc":"Creates a new step error for a step execution failure.\n\nWhen a step implementation raises an exception or returns `{:error, reason}`,\nthis function creates a detailed error message with context about the failure.","ref":"Cucumber.StepError.html#failed_step/6"},{"type":"function","title":"Parameters - Cucumber.StepError.failed_step/6","doc":"* `step` - The `Gherkin.Step` struct that failed during execution\n* `pattern` - The step pattern that matched the step\n* `failure_reason` - The exception or error reason\n* `feature_file` - The path to the feature file containing the step\n* `scenario_name` - The name of the scenario containing the step\n* `step_history` - A list of previously executed steps with their status","ref":"Cucumber.StepError.html#failed_step/6-parameters"},{"type":"function","title":"Returns - Cucumber.StepError.failed_step/6","doc":"Returns a `Cucumber.StepError` struct with a formatted error message and context.","ref":"Cucumber.StepError.html#failed_step/6-returns"},{"type":"function","title":"Examples - Cucumber.StepError.failed_step/6","doc":"The error message will include details like:\n\n    Step failed:\n\n      Then the result should be 10\n\n    in scenario \"Basic math\" (test/features/calculator.feature:12)\n    matching pattern: \"the result should be {int}\"\n\n    Expected 10 but got 9\n\n    Step execution history:\n      [passed] Given I have entered 5 into the calculator\n      [passed] And I have entered 4 into the calculator\n      [passed] When I press add\n      [failed] Then the result should be 10","ref":"Cucumber.StepError.html#failed_step/6-examples"},{"type":"function","title":"Cucumber.StepError.missing_step_definition/4","doc":"Creates a new step error for a missing step definition.\n\nWhen a step in a feature file doesn't match any step definition, this function\ncreates a helpful error message that includes a suggestion for implementing\nthe missing step.","ref":"Cucumber.StepError.html#missing_step_definition/4"},{"type":"function","title":"Parameters - Cucumber.StepError.missing_step_definition/4","doc":"* `step` - The `Gherkin.Step` struct that has no matching definition\n* `feature_file` - The path to the feature file containing the step\n* `scenario_name` - The name of the scenario containing the step\n* `step_history` - A list of previously executed steps with their status","ref":"Cucumber.StepError.html#missing_step_definition/4-parameters"},{"type":"function","title":"Returns - Cucumber.StepError.missing_step_definition/4","doc":"Returns a `Cucumber.StepError` struct with a formatted error message and context.","ref":"Cucumber.StepError.html#missing_step_definition/4-returns"},{"type":"function","title":"Examples - Cucumber.StepError.missing_step_definition/4","doc":"The error message will include a suggested implementation like:\n\n    step \"I click the submit button\", context do\n      # Your step implementation here\n      context\n    end","ref":"Cucumber.StepError.html#missing_step_definition/4-examples"},{"type":"type","title":"Cucumber.StepError.t/0","doc":"","ref":"Cucumber.StepError.html#t:t/0"},{"type":"extras","title":"Getting Started with Cucumber for Elixir","doc":"# Getting Started with Cucumber for Elixir\n\nCucumber for Elixir allows you to write executable specifications using natural language that bridges the gap between technical and non-technical stakeholders.","ref":"getting_started.html"},{"type":"extras","title":"Overview - Getting Started with Cucumber for Elixir","doc":"The Cucumber framework allows you to write tests in a natural language format using Gherkin syntax. This approach enables:\n\n- Behavior-driven development (BDD)\n- Clear documentation of application behavior\n- Tests that serve as living documentation\n- Auto-discovery of feature files and step definitions","ref":"getting_started.html#overview"},{"type":"extras","title":"Installation - Getting Started with Cucumber for Elixir","doc":"Add `cucumber` to your `mix.exs` dependencies:\n\n```elixir\ndef deps do\n  [\n    {:cucumber, \"~> 0.2.0\"}\n  ]\nend\n```","ref":"getting_started.html#installation"},{"type":"extras","title":"Quick Start - Getting Started with Cucumber for Elixir","doc":"","ref":"getting_started.html#quick-start"},{"type":"extras","title":"1. Configure Test Helper - Getting Started with Cucumber for Elixir","doc":"Add Cucumber to your `test/test_helper.exs`:\n\n```elixir\nExUnit.start()\nCucumber.compile_features!()\n```","ref":"getting_started.html#1-configure-test-helper"},{"type":"extras","title":"2. Create a Feature File - Getting Started with Cucumber for Elixir","doc":"Feature files use the Gherkin syntax and should be placed in `test/features/` with a `.feature` extension.\n\n```gherkin\n# test/features/user_authentication.feature\nFeature: User Authentication\n\nBackground:\n  Given the application is running\n\nScenario: User signs in with valid credentials\n  Given I am on the sign in page\n  When I enter \"user@example.com\" as my email\n  And I enter \"password123\" as my password\n  And I click the \"Sign In\" button\n  Then I should be redirected to the dashboard\n  And I should see \"Welcome back\" message\n```","ref":"getting_started.html#2-create-a-feature-file"},{"type":"extras","title":"3. Create Step Definitions - Getting Started with Cucumber for Elixir","doc":"Create step definitions in `test/features/step_definitions/` with a `.exs` extension:\n\n```elixir\n# test/features/step_definitions/authentication_steps.exs\ndefmodule AuthenticationSteps do\n  use Cucumber.StepDefinition\n  import ExUnit.Assertions\n  \n  # Step definitions\n  step \"the application is running\" do\n    # Setup code here\n    %{app_started: true}\n  end\n  \n  step \"I am on the sign in page\", context do\n    # Navigate to sign in page\n    Map.put(context, :current_page, :sign_in)\n  end\n  \n  step \"I enter {string} as my email\", %{args: [email]} = context do\n    # Code to enter email\n    Map.put(context, :email, email)\n  end\n\n  step \"I enter {string} as my password\", %{args: [password]} = context do\n    # Code to enter password\n    Map.put(context, :password, password)\n  end\n  \n  step \"I click the {string} button\", %{args: [button_text]} do\n    # Code to click button\n    {:ok, %{clicked: button_text}}\n  end\n  \n  step \"I should be redirected to the dashboard\", context do\n    # Assertions for redirection\n    assert context.current_page == :dashboard\n    context\n  end\n  \n  step \"I should see {string} message\", %{args: [message]} do\n    # Assertion for message\n    assert_text(message)\n    :ok\n  end\nend\n```","ref":"getting_started.html#3-create-step-definitions"},{"type":"extras","title":"4. Run Your Tests - Getting Started with Cucumber for Elixir","doc":"Run your tests using the standard mix test command:\n\n```bash\n# Run all tests including Cucumber\nmix test\n\n# Run only Cucumber tests\nmix test --only cucumber\n\n# Run tests for a specific feature\nmix test --only feature_user_authentication\n```","ref":"getting_started.html#4-run-your-tests"},{"type":"extras","title":"File Structure - Getting Started with Cucumber for Elixir","doc":"Cucumber automatically discovers features and steps using this structure:\n\n```\ntest/\n  features/                      # Feature files\n    user_authentication.feature\n    shopping_cart.feature\n    step_definitions/           # Step definition files\n      authentication_steps.exs\n      shopping_steps.exs\n      common_steps.exs\n```","ref":"getting_started.html#file-structure"},{"type":"extras","title":"Async Test Execution - Getting Started with Cucumber for Elixir","doc":"For features that don't share state, you can enable concurrent test execution by adding the `@async` tag:\n\n```gherkin\n# test/features/calculator.feature\n@async\nFeature: Calculator Operations\n  Independent calculations that can run concurrently\n\nScenario: Addition\n  Given I have numbers 10 and 20\n  When I add them together\n  Then the result should be 30\n\nScenario: Multiplication\n  Given I have numbers 5 and 6\n  When I multiply them\n  Then the result should be 30\n```\n\nAsync features run concurrently with other async tests, improving test suite performance. Only use `@async` for features that are truly independent and don't rely on test execution order.\n\nWhen using Ecto, async tests work well with the SQL sandbox in shared mode. See your application's test setup for database configuration.","ref":"getting_started.html#async-test-execution"},{"type":"extras","title":"Next Steps - Getting Started with Cucumber for Elixir","doc":"For more detailed information about the Cucumber for Elixir framework, check out these guides:\n\n- [Feature Files](./feature_files.md) - Learn how to write feature files with Gherkin syntax\n- [Step Definitions](./step_definitions.md) - Learn how to implement step definitions\n- [Error Handling](./error_handling.md) - Understanding error reporting and debugging\n- [Best Practices](./best_practices.md) - Best practices and examples","ref":"getting_started.html#next-steps"},{"type":"extras","title":"Writing Feature Files","doc":"# Writing Feature Files\n\nFeature files are the heart of Cucumber testing. They're written in Gherkin syntax, a business-readable domain-specific language that lets you describe application behavior without detailing how that behavior is implemented.","ref":"feature_files.html"},{"type":"extras","title":"Feature File Structure - Writing Feature Files","doc":"Feature files consist of several components:","ref":"feature_files.html#feature-file-structure"},{"type":"extras","title":"Feature - Writing Feature Files","doc":"Every feature file starts with the `Feature:` keyword followed by a name and optional description:\n\n```gherkin\nFeature: Shopping Cart\n  As a user\n  I want to add items to my cart\n  So that I can purchase them later\n```","ref":"feature_files.html#feature"},{"type":"extras","title":"Background - Writing Feature Files","doc":"The `Background:` section contains steps that are executed before each scenario:\n\n```gherkin\nBackground:\n  Given I am logged in as a customer\n  And the product catalog is available\n```","ref":"feature_files.html#background"},{"type":"extras","title":"Scenarios - Writing Feature Files","doc":"Scenarios are concrete examples of how the feature should behave:\n\n```gherkin\nScenario: Adding an item to an empty cart\n  Given I am on the product page for \"Ergonomic Keyboard\"\n  When I click \"Add to Cart\"\n  Then I should see \"Item added to cart\" message\n  And my cart should contain 1 item\n```","ref":"feature_files.html#scenarios"},{"type":"extras","title":"Steps - Writing Feature Files","doc":"Steps use keywords like `Given`, `When`, `Then`, `And`, and `But`:\n\n- `Given`: Establishes preconditions\n- `When`: Describes actions\n- `Then`: Specifies expected outcomes\n- `And`/`But`: Continues the previous step type","ref":"feature_files.html#steps"},{"type":"extras","title":"Step Arguments - Writing Feature Files","doc":"Gherkin supports several types of step arguments:","ref":"feature_files.html#step-arguments"},{"type":"extras","title":"Data Tables - Writing Feature Files","doc":"```gherkin\nScenario: Adding multiple items to cart\n  Given I have the following items in my cart:\n    | Product Name    | Quantity | Price |\n    | Smartphone      | 1        | 699.99|\n    | Protection Plan | 1        | 79.99 |\n  When I proceed to checkout\n  Then the total should be 779.98\n```","ref":"feature_files.html#data-tables"},{"type":"extras","title":"Doc Strings - Writing Feature Files","doc":"```gherkin\nScenario: Submit feedback\n  When I submit the following feedback:\n    \"\"\"\n    I really like your product, but I think\n    it could be improved by adding more features.\n    Keep up the good work!\n    \"\"\"\n  Then my feedback should be recorded\n```","ref":"feature_files.html#doc-strings"},{"type":"extras","title":"File Organization - Writing Feature Files","doc":"Feature files should be placed in a `test/features/` directory and have a `.feature` extension. Organize them logically by feature or domain area:\n\n```\ntest/\n└── features/\n    ├── authentication/\n    │   ├── login.feature\n    │   └── registration.feature\n    ├── shopping/\n    │   ├── cart.feature\n    │   └── checkout.feature\n    └── user_profile.feature\n```","ref":"feature_files.html#file-organization"},{"type":"extras","title":"Tags - Writing Feature Files","doc":"Tags are used to categorize scenarios and can be used for filtering which tests to run:\n\n```gherkin\n@authentication @important\nFeature: User Login\n\n@happy_path\nScenario: Successful login with valid credentials\n  Given I am on the login page\n  When I enter valid credentials\n  Then I should be logged in\n\n@error_handling\nScenario: Failed login with invalid credentials\n  Given I am on the login page\n  When I enter invalid credentials\n  Then I should see an error message\n```\n\nTags can be used at the Feature level (applies to all scenarios) or at the Scenario level.","ref":"feature_files.html#tags"},{"type":"extras","title":"Special Tags - Writing Feature Files","doc":"#### @async\n\nThe `@async` tag enables concurrent test execution for features that don't share state:\n\n```gherkin\n@async\nFeature: Independent Calculator Operations\n  This feature can run concurrently with other async tests\n\nScenario: Addition\n  Given I have a calculator\n  When I add 5 and 3\n  Then the result should be 8\n\nScenario: Multiplication\n  Given I have a calculator\n  When I multiply 4 and 7\n  Then the result should be 28\n```\n\nUse `@async` only for features that:\n- Don't share state with other tests\n- Don't rely on test execution order\n- Are truly independent of other tests\n\nNote: Database tests can safely run async when using Ecto's SQL sandbox in shared mode. For non-Ecto resources (files, external APIs, etc.), ensure they can handle concurrent access.","ref":"feature_files.html#special-tags"},{"type":"extras","title":"Best Practices for Feature Files - Writing Feature Files","doc":"1. **Keep language simple and consistent** - Use clear, business-focused terminology\n2. **One scenario per behavior** - Each scenario should test one specific behavior\n3. **Be specific in examples** - Use concrete values rather than vague descriptions\n4. **Use background wisely** - Only for steps that are truly common to all scenarios\n5. **Limit scenario length** - If a scenario has many steps, consider breaking it down\n6. **Organize with tags** - Use tags to categorize and group related scenarios\n7. **Think like a user** - Write scenarios from the user's perspective\n8. **Don't get too technical** - Avoid technical implementation details in Gherkin","ref":"feature_files.html#best-practices-for-feature-files"},{"type":"extras","title":"Step Definitions","doc":"# Step Definitions\n\nStep definitions connect the Gherkin steps in your feature files to actual code. They're the glue between your natural language specifications and the implementation that tests your application.","ref":"step_definitions.html"},{"type":"extras","title":"Creating Step Definition Files - Step Definitions","doc":"Step definitions should be placed in `test/features/step_definitions/` with a `.exs` extension:\n\n```elixir\n# test/features/step_definitions/authentication_steps.exs\ndefmodule AuthenticationSteps do\n  use Cucumber.StepDefinition\n  import ExUnit.Assertions\n  \n  # Step definitions go here\nend\n```","ref":"step_definitions.html#creating-step-definition-files"},{"type":"extras","title":"Basic Step Definition - Step Definitions","doc":"Step definitions are created using the `step` macro:\n\n```elixir\nstep \"I am logged in as a customer\", context do\n  # Authentication logic here\n  Map.put(context, :user, create_and_login_customer())\nend\n```","ref":"step_definitions.html#basic-step-definition"},{"type":"extras","title":"Steps with Parameters - Step Definitions","doc":"Cucumber supports several parameter types that can be used in step patterns. Parameters are accessed through pattern matching on the `args` field of the context:","ref":"step_definitions.html#steps-with-parameters"},{"type":"extras","title":"String Parameters - Step Definitions","doc":"```elixir\nstep \"I am on the product page for {string}\", %{args: [product_name]} do\n  # Navigate to product page\n  %{current_page: :product, product_name: product_name}\nend\n```","ref":"step_definitions.html#string-parameters"},{"type":"extras","title":"Integer Parameters - Step Definitions","doc":"```elixir\nstep \"I should have {int} items in my wishlist\", %{args: [expected_count]} = context do\n  # Assertion for wishlist count\n  assert get_wishlist_count(context) == expected_count\n  context\nend\n```","ref":"step_definitions.html#integer-parameters"},{"type":"extras","title":"Float Parameters - Step Definitions","doc":"```elixir\nstep \"the total price should be {float}\", %{args: [expected_total]} = context do\n  # Assertion for price\n  assert_in_delta get_cart_total(context), expected_total, 0.01\n  context\nend\n```","ref":"step_definitions.html#float-parameters"},{"type":"extras","title":"Word Parameters - Step Definitions","doc":"```elixir\nstep \"I should see the {word} dashboard\", %{args: [dashboard_type]} = context do\n  # Assertion for dashboard type\n  assert get_current_dashboard(context) == dashboard_type\n  context\nend\n```","ref":"step_definitions.html#word-parameters"},{"type":"extras","title":"Multiple Parameters - Step Definitions","doc":"When a step has multiple parameters, you can pattern match on all of them:\n\n```elixir\nstep \"I transfer {float} from {string} to {string}\", %{args: [amount, from_account, to_account]} do\n  # Transfer logic\n  %{transfer: %{amount: amount, from: from_account, to: to_account}}\nend\n```","ref":"step_definitions.html#multiple-parameters"},{"type":"extras","title":"Working with Data Tables - Step Definitions","doc":"In your feature file:\n```gherkin\nGiven I have the following items in my cart:\n  | Product Name    | Quantity | Price |\n  | Smartphone      | 1        | 699.99|\n  | Protection Plan | 1        | 79.99 |\n```\n\nIn your step definitions:\n```elixir\nstep \"I have the following items in my cart:\", context do\n  # Access the datatable\n  datatable = context.datatable\n\n  # Access headers\n  headers = datatable.headers  # [\"Product Name\", \"Quantity\", \"Price\"]\n  \n  # Access rows as maps\n  items = datatable.maps\n  # [\n  #   %{\"Product Name\" => \"Smartphone\", \"Quantity\" => \"1\", \"Price\" => \"699.99\"},\n  #   %{\"Product Name\" => \"Protection Plan\", \"Quantity\" => \"1\", \"Price\" => \"79.99\"}\n  # ]\n  \n  # Process the items\n  Map.put(context, :cart_items, items)\nend\n```","ref":"step_definitions.html#working-with-data-tables"},{"type":"extras","title":"Working with DocStrings - Step Definitions","doc":"DocStrings allow you to pass multi-line text to a step:\n\nIn your feature file:\n```gherkin\nWhen I submit the following JSON:\n  \"\"\"\n  {\n    \"name\": \"Test Product\",\n    \"price\": 29.99,\n    \"available\": true\n  }\n  \"\"\"\n```\n\nIn your step definitions:\n```elixir\nstep \"I submit the following JSON:\", context do\n  # The docstring is available in context.docstring\n  json_data = Jason.decode!(context.docstring)\n  \n  # Process the JSON\n  Map.put(context, :submitted_data, json_data)\nend\n```","ref":"step_definitions.html#working-with-docstrings"},{"type":"extras","title":"Return Values - Step Definitions","doc":"Step definitions must return one of the following values (matching ExUnit's setup behavior):\n\n- `:ok` - Keeps the context unchanged\n- A map - Merged into the existing context\n- A keyword list - Merged into the existing context\n- `{:ok, map_or_keyword_list}` - Merged into the existing context\n- `{:error, reason}` - Fails the step with the given reason","ref":"step_definitions.html#return-values"},{"type":"extras","title":"Reusable Step Definitions - Step Definitions","doc":"You can create reusable step definitions that can be shared across multiple features:\n\n```elixir\n# test/features/step_definitions/common_steps.exs\ndefmodule CommonSteps do\n  use Cucumber.StepDefinition\n  import ExUnit.Assertions\n  \n  step \"I wait {int} seconds\", %{args: [seconds]} = context do\n    Process.sleep(seconds * 1000)\n    context\n  end\n  \n  step \"I should see {string}\", %{args: [text]} = context do\n    assert page_contains_text?(context, text)\n    context\n  end\nend\n```","ref":"step_definitions.html#reusable-step-definitions"},{"type":"extras","title":"Best Practices - Step Definitions","doc":"1. **Keep steps focused**: Each step should do one thing well\n2. **Use descriptive step patterns**: Make your steps readable and self-documenting\n3. **Share common steps**: Create reusable step definitions for common actions\n4. **Handle errors gracefully**: Return `{:error, reason}` for expected failures\n5. **Maintain context**: Always return the context (or `:ok`) to maintain state between steps","ref":"step_definitions.html#best-practices"},{"type":"extras","title":"Error Handling and Debugging","doc":"# Error Handling and Debugging\n\nCucumber for Elixir provides detailed error reporting to help debug test failures. This document explains how to handle and understand errors in your Cucumber tests.","ref":"error_handling.html"},{"type":"extras","title":"Types of Errors - Error Handling and Debugging","doc":"","ref":"error_handling.html#types-of-errors"},{"type":"extras","title":"Missing Step Definition - Error Handling and Debugging","doc":"When a step in your feature file has no matching definition, the framework will provide a helpful error message:\n\n```\n** (Cucumber.StepError) No matching step definition found for step:\n\n  When I try to use a step with no definition\n\nin scenario \"Missing Step Example\" (test/features/example.feature:6)\n\nPlease define this step with:\n\nstep \"I try to use a step with no definition\", context do\n  # Your step implementation here\n  context\nend\n```\n\nThis error not only tells you which step is missing, but also provides a template for implementing the missing step definition.","ref":"error_handling.html#missing-step-definition"},{"type":"extras","title":"Failed Step - Error Handling and Debugging","doc":"When a step fails during execution (due to a failed assertion or an exception), you'll get an error like this:\n\n```\n** (Cucumber.StepError) Step failed:\n\n  Then the validation should succeed\n\nin scenario \"Form Submission\" (test/features/forms.feature:12)\nmatching pattern: \"the validation should succeed\"\n\nValidation failed: invalid input data\n\nStep execution history:\n  [passed] Given a form to fill out\n  [passed] When I submit invalid data\n  [failed] Then the validation should succeed\n```\n\nThe error message includes:\n- Which step failed\n- The scenario and file where the failure occurred\n- The step pattern that matched\n- The error message from the step implementation\n- The execution history, showing which steps passed and which failed","ref":"error_handling.html#failed-step"},{"type":"extras","title":"Syntax Errors in Feature Files - Error Handling and Debugging","doc":"If there are syntax errors in your feature files, you'll get an error when the parser tries to process the file:\n\n```\n** (Cucumber.ParseError) Syntax error in feature file:\n\n  test/features/invalid.feature:5\n\nExpected a scenario or background but found:\n  \n  Invalid line that doesn't start with a Gherkin keyword\n```","ref":"error_handling.html#syntax-errors-in-feature-files"},{"type":"extras","title":"Step Failure Handling - Error Handling and Debugging","doc":"Step definitions can indicate failure in several ways:","ref":"error_handling.html#step-failure-handling"},{"type":"extras","title":"1. Assertions - Error Handling and Debugging","doc":"Using ExUnit assertions will cause the step to fail if the assertion fails:\n\n```elixir\nstep \"the total should be {float}\", %{args: [total]} = context do\n  assert context.cart_total == total\n  :ok\nend\n```","ref":"error_handling.html#1-assertions"},{"type":"extras","title":"2. Raising Exceptions - Error Handling and Debugging","doc":"Any uncaught exception will cause the step to fail:\n\n```elixir\nstep \"I click the submit button\", _context do\n  raise \"The submit button is disabled\"\n  :ok\nend\n```","ref":"error_handling.html#2-raising-exceptions"},{"type":"extras","title":"3. Returning {:error, reason} - Error Handling and Debugging","doc":"You can explicitly return an error tuple to fail a step:\n\n```elixir\nstep \"the payment should be successful\", context do\n  if context.payment_status == :success do\n    :ok\n  else\n    {:error, \"Expected payment to succeed, but got status: #{context.payment_status}\"}\n  end\nend\n```","ref":"error_handling.html#3-returning-error-reason"},{"type":"extras","title":"Debugging Tips - Error Handling and Debugging","doc":"","ref":"error_handling.html#debugging-tips"},{"type":"extras","title":"1. Use IO.inspect for Debug Output - Error Handling and Debugging","doc":"Insert `IO.inspect` calls to see the values of variables during test execution:\n\n```elixir\nstep \"I should see my order summary\", context do\n  IO.inspect(context, label: \"Context in order summary step\")\n  assert context.order != nil\n  :ok\nend\n```","ref":"error_handling.html#1-use-io-inspect-for-debug-output"},{"type":"extras","title":"2. Add Step Execution Logs - Error Handling and Debugging","doc":"Log information about step execution:\n\n```elixir\nstep \"I complete the checkout process\", context do\n  IO.puts(\"Starting checkout process\")\n  # Checkout logic\n  IO.puts(\"Completed checkout process\")\n  :ok\nend\n```","ref":"error_handling.html#2-add-step-execution-logs"},{"type":"extras","title":"3. Examine the Full Context - Error Handling and Debugging","doc":"Print the full context at any point to see the accumulated state:\n\n```elixir\nstep \"I check my context\", context do\n  IO.inspect(context, label: \"Current context\", pretty: true)\n  :ok\nend\n```","ref":"error_handling.html#3-examine-the-full-context"},{"type":"extras","title":"4. Create Debug-Only Steps - Error Handling and Debugging","doc":"Add steps specifically for debugging:\n\n```elixir\nstep \"I debug my test state\", context do\n  IO.puts(\"==== DEBUG STATE ====\")\n  IO.inspect(context.current_page, label: \"Current Page\")\n  IO.inspect(context.user, label: \"Current User\")\n  IO.inspect(context.cart_items, label: \"Cart Items\")\n  IO.puts(\"==== END DEBUG ====\")\n  :ok\nend\n```","ref":"error_handling.html#4-create-debug-only-steps"},{"type":"extras","title":"Handling Flaky Tests - Error Handling and Debugging","doc":"Sometimes tests can be inconsistent due to timing issues, especially with UI interactions:\n\n```elixir\nstep \"I should see the confirmation message\", context do\n  # Add delay or retry logic for UI-related assertions\n  :timer.sleep(500)  # Give the UI time to update\n  assert_text(\"Your order has been confirmed\")\n  :ok\nend\n```\n\nConsider implementing retry logic for flaky steps:\n\n```elixir\ndefp retry_until(function, max_attempts \\\\ 5, delay \\\\ 100) do\n  Enum.reduce_while(1..max_attempts, nil, fn attempt, _acc ->\n    case function.() do\n      {:ok, result} -> {:halt, {:ok, result}}\n      {:error, reason} ->\n        if attempt == max_attempts do\n          {:halt, {:error, reason}}\n        else\n          :timer.sleep(delay)\n          {:cont, nil}\n        end\n    end\n  end)\nend\n\nstep \"I should see the success notification\", _context do\n  result = retry_until(fn ->\n    if element_visible?(\".success-notification\") do\n      {:ok, true}\n    else\n      {:error, \"Success notification not visible\"}\n    end\n  end)\n  \n  case result do\n    {:ok, _} -> :ok\n    {:error, reason} -> {:error, reason}\n  end\nend\n```","ref":"error_handling.html#handling-flaky-tests"},{"type":"extras","title":"Common Error Patterns and Solutions - Error Handling and Debugging","doc":"| Error Pattern | Possible Cause | Solution |\n|---------------|----------------|----------|\n| Step not found | Step definition missing or typo in step | Create the missing step definition or correct the typo |\n| Assertion failure | Expected value doesn't match actual | Check your test data and application logic |\n| Timeout | Asynchronous operation didn't complete in time | Increase timeout or add retry logic |\n| Element not found | UI element not rendered yet or selector wrong | Add delay, retry, or correct the selector |\n| Context key missing | Previous step didn't set expected data | Ensure required context keys are set in earlier steps |","ref":"error_handling.html#common-error-patterns-and-solutions"},{"type":"extras","title":"Best Practices for Cucumber Tests","doc":"# Best Practices for Cucumber Tests\n\nThis guide outlines best practices for writing and organizing your Cucumber tests to ensure they remain maintainable, readable, and effective.","ref":"best_practices.html"},{"type":"extras","title":"Feature File Organization - Best Practices for Cucumber Tests","doc":"","ref":"best_practices.html#feature-file-organization"},{"type":"extras","title":"Directory Structure - Best Practices for Cucumber Tests","doc":"```\ntest/\n├── features/                    # Feature files\n│   ├── authentication/          # Feature grouping by domain\n│   │   ├── login.feature\n│   │   └── registration.feature\n│   ├── shopping/               # Another domain\n│   │   ├── cart.feature\n│   │   └── checkout.feature\n│   └── step_definitions/       # Step definition files\n│       ├── authentication_steps.exs\n│       ├── shopping_steps.exs\n│       └── common_steps.exs\n```","ref":"best_practices.html#directory-structure"},{"type":"extras","title":"Naming Conventions - Best Practices for Cucumber Tests","doc":"- Use snake_case for feature file names\n- Group related features into subdirectories\n- Name step definition modules descriptively (e.g., `AuthenticationSteps`, `ShoppingSteps`)\n- Use `.exs` extension for step definition files","ref":"best_practices.html#naming-conventions"},{"type":"extras","title":"Writing Good Scenarios - Best Practices for Cucumber Tests","doc":"","ref":"best_practices.html#writing-good-scenarios"},{"type":"extras","title":"Scenario Best Practices - Best Practices for Cucumber Tests","doc":"1. **Keep scenarios focused**: Each scenario should test one specific behavior\n2. **Be consistent**: Use consistent language across scenarios\n3. **Use concrete examples**: Prefer specific, realistic values to abstract placeholders\n4. **Avoid technical details**: Keep scenarios in business language\n5. **Keep them short**: Aim for 3-7 steps per scenario\n6. **Use backgrounds wisely**: Only for truly common setup steps","ref":"best_practices.html#scenario-best-practices"},{"type":"extras","title":"Example: Bad vs. Good - Best Practices for Cucumber Tests","doc":"Bad:\n```gherkin\nScenario: User interaction\n  Given a user\n  When the user does stuff\n  Then the outcome is good\n```\n\nGood:\n```gherkin\nScenario: Customer adds product to shopping cart\n  Given I am logged in as \"alice@example.com\"\n  And I am viewing the \"iPhone 15 Pro\" product page\n  When I click \"Add to Cart\"\n  Then I should see \"iPhone 15 Pro\" in my shopping cart\n  And the cart total should be $999.00\n```","ref":"best_practices.html#example-bad-vs-good"},{"type":"extras","title":"Step Definition Best Practices - Best Practices for Cucumber Tests","doc":"","ref":"best_practices.html#step-definition-best-practices"},{"type":"extras","title":"Keep Steps Reusable - Best Practices for Cucumber Tests","doc":"Write generic steps that can be reused across features:\n\n```elixir\n# Good - reusable\nstep \"I click {string}\", %{args: [button_text]} = context do\n  click_button(context, button_text)\nend\n\n# Less reusable - too specific\nstep \"I click the red submit button on the login form\", context do\n  click_specific_button(context)\nend\n```","ref":"best_practices.html#keep-steps-reusable"},{"type":"extras","title":"Use the Context Effectively - Best Practices for Cucumber Tests","doc":"Pass data between steps using the context:\n\n```elixir\nstep \"I create a product named {string}\", %{args: [name]} = context do\n  product = create_product(name: name)\n  Map.put(context, :product, product)\nend\n\nstep \"I should see the product in my catalog\", context do\n  assert product_in_catalog?(context.product)\n  context\nend\n```","ref":"best_practices.html#use-the-context-effectively"},{"type":"extras","title":"Organize Step Definitions - Best Practices for Cucumber Tests","doc":"Group related steps in the same module:\n\n```elixir\n# test/features/step_definitions/authentication_steps.exs\ndefmodule AuthenticationSteps do\n  use Cucumber.StepDefinition\n  import ExUnit.Assertions\n  \n  # Login steps\n  step \"I am logged in as {string}\", %{args: [email]} = context do\n    user = login_user(email)\n    Map.put(context, :current_user, user)\n  end\n  \n  # Registration steps\n  step \"I register with email {string}\", %{args: [email]} = context do\n    user = register_user(email: email)\n    Map.put(context, :new_user, user)\n  end\nend\n```","ref":"best_practices.html#organize-step-definitions"},{"type":"extras","title":"Common Patterns - Best Practices for Cucumber Tests","doc":"","ref":"best_practices.html#common-patterns"},{"type":"extras","title":"Data Setup Pattern - Best Practices for Cucumber Tests","doc":"Create helper functions for common data setup:\n\n```elixir\ndefmodule TestHelpers do\n  def create_user(attrs \\\\ %{}) do\n    default_attrs = %{\n      email: \"test@example.com\",\n      name: \"Test User\"\n    }\n    \n    attrs = Map.merge(default_attrs, attrs)\n    # Create user logic\n  end\nend\n\n# In your steps\nstep \"a user exists with email {string}\", %{args: [email]} do\n  user = TestHelpers.create_user(email: email)\n  %{user: user}\nend\n```","ref":"best_practices.html#data-setup-pattern"},{"type":"extras","title":"Assertion Helpers - Best Practices for Cucumber Tests","doc":"Create custom assertion helpers for cleaner steps:\n\n```elixir\ndefmodule AssertionHelpers do\n  import ExUnit.Assertions\n  \n  def assert_logged_in(context) do\n    assert context[:current_user] != nil\n    assert context[:session_token] != nil\n  end\n  \n  def assert_product_visible(context, product_name) do\n    assert product_name in get_visible_products(context)\n  end\nend\n```","ref":"best_practices.html#assertion-helpers"},{"type":"extras","title":"Testing Tips - Best Practices for Cucumber Tests","doc":"","ref":"best_practices.html#testing-tips"},{"type":"extras","title":"Use Tags for Organization - Best Practices for Cucumber Tests","doc":"Tag your scenarios for easy filtering:\n\n```gherkin\n@authentication @smoke\nScenario: Successful login\n  Given I am on the login page\n  When I enter valid credentials\n  Then I should be logged in\n\n@wip @slow\nScenario: Complex data processing\n  Given a large dataset\n  When I process the data\n  Then the results should be accurate\n```\n\nRun specific tags:\n```bash\nmix test --only authentication\nmix test --exclude wip\n```","ref":"best_practices.html#use-tags-for-organization"},{"type":"extras","title":"Background vs. Helper Steps - Best Practices for Cucumber Tests","doc":"Use backgrounds for truly common setup that applies to all scenarios:\n\n```gherkin\nBackground:\n  Given the system is initialized\n  And default products exist\n\nScenario: View product catalog\n  When I visit the catalog page\n  Then I should see all products\n```","ref":"best_practices.html#background-vs-helper-steps"},{"type":"extras","title":"Handling Asynchronous Operations - Best Practices for Cucumber Tests","doc":"For operations that might take time:\n\n```elixir\nstep \"I wait for the email to arrive\", context do\n  # Poll for the email with a timeout\n  email = wait_for_email(context.current_user.email, timeout: 5_000)\n  Map.put(context, :received_email, email)\nend\n\ndefp wait_for_email(email, opts) do\n  timeout = Keyword.get(opts, :timeout, 5_000)\n  poll_interval = 100\n  \n  wait_until(timeout, poll_interval, fn ->\n    check_email_arrived(email)\n  end)\nend\n```","ref":"best_practices.html#handling-asynchronous-operations"},{"type":"extras","title":"Debugging Tips - Best Practices for Cucumber Tests","doc":"1. **Use IO.inspect in steps**: Temporarily add `IO.inspect(context)` to see the current state\n2. **Run single scenarios**: Focus on one test at a time during debugging\n3. **Check step history**: Error messages show which steps ran before failure\n4. **Use meaningful assertions**: Include context in assertion messages\n\n```elixir\nstep \"the order should be completed\", context do\n  order = context.order\n  assert order.status == \"completed\", \n         \"Expected order #{order.id} to be completed, but was #{order.status}\"\n  context\nend\n```","ref":"best_practices.html#debugging-tips"},{"type":"extras","title":"Cucumber Architecture","doc":"# Cucumber Architecture\n\nThis document provides an overview of the Cucumber implementation architecture, explaining the core components and how they interact.","ref":"architecture.html"},{"type":"extras","title":"Core Components - Cucumber Architecture","doc":"```\nCucumber\n  ├── Discovery (Feature/Step Finding)\n  ├── Gherkin (Parser)\n  ├── Expression (Parameter Matching)\n  ├── Compiler (Test Generation)\n  ├── Runtime (Step Execution)\n  └── StepError (Error Reporting)\n```","ref":"architecture.html#core-components"},{"type":"extras","title":"Discovery System - Cucumber Architecture","doc":"The discovery system automatically finds and loads feature files and step definitions:\n\n```elixir\nDiscovery.discover()\n  ├── Scans for features (test/features/**/*.feature)\n  ├── Loads step definitions (test/features/step_definitions/**/*.exs)\n  └── Returns: %{features: [...], step_registry: %{...}}\n```","ref":"architecture.html#discovery-system"},{"type":"extras","title":"Gherkin Parser - Cucumber Architecture","doc":"The Gherkin parser is responsible for parsing `.feature` files into a structured format that can be executed. It handles the syntax of Gherkin, including:\n\n- Feature declarations\n- Scenario outlines\n- Backgrounds\n- Steps (Given, When, Then)\n- Tables and doc strings\n- Tags\n\nThe parser produces an Abstract Syntax Tree (AST) that represents the structure of the feature file.\n\n```elixir\n# Simplified representation of the Gherkin parser flow\nFeature File (Text) → Lexer → Tokens → Parser → AST\n```","ref":"architecture.html#gherkin-parser"},{"type":"extras","title":"Expression Engine - Cucumber Architecture","doc":"The Expression engine is responsible for matching step text against step definitions. It supports:\n\n- Regular expressions\n- Cucumber expressions (a simplified syntax with parameter types)\n- Parameter conversion (string to typed values)\n\n```elixir\ndefmodule Cucumber.Expression do\n  # Converts a cucumber expression into a regex and parameter converters\n  def compile(pattern) do\n    # Transforms {string}, {int}, etc. into regex patterns\n    # Returns {regex, converters}\n  end\n\n  # Matches text against a compiled expression\n  def match(text, {regex, converters}) do\n    # Returns {:match, args} or :no_match\n  end\nend\n```","ref":"architecture.html#expression-engine"},{"type":"extras","title":"Compiler - Cucumber Architecture","doc":"The compiler generates ExUnit test modules from discovered features:\n\n```elixir\nCompiler.compile_features!()\n  ├── For each feature file:\n  │   ├── Generates a test module\n  │   ├── Creates setup from Background\n  │   ├── Creates test cases from Scenarios\n  │   └── Adds appropriate tags\n  └── Compiles modules into memory\n```","ref":"architecture.html#compiler"},{"type":"extras","title":"Runtime - Cucumber Architecture","doc":"The runtime executes steps during test runs:\n\n```elixir\nRuntime.execute_step(context, step, step_registry)\n  ├── Finds matching step definition\n  ├── Prepares context with args, datatables, docstrings\n  ├── Executes step function\n  └── Processes return value\n```","ref":"architecture.html#runtime"},{"type":"extras","title":"StepDefinition Macro - Cucumber Architecture","doc":"The StepDefinition module provides the DSL for defining steps:\n\n```elixir\ndefmodule MySteps do\n  use Cucumber.StepDefinition\n  \n  step \"pattern\", context do\n    # implementation\n  end\nend\n```","ref":"architecture.html#stepdefinition-macro"},{"type":"extras","title":"Execution Flow - Cucumber Architecture","doc":"1. **Discovery Phase** (at compile time)\n   - `Cucumber.compile_features!()` is called in test_helper.exs\n   - Discovery system finds all features and step definitions\n   - Step registry is built with pattern → module mappings\n\n2. **Compilation Phase**\n   - For each feature, a test module is generated\n   - Background steps become setup blocks\n   - Scenarios become test cases\n   - Tags are added for filtering\n\n3. **Execution Phase** (at runtime)\n   - ExUnit runs the generated test modules\n   - Each test executes its steps via Runtime\n   - Context is passed between steps\n   - Errors are reported with helpful messages","ref":"architecture.html#execution-flow"},{"type":"extras","title":"Data Flow - Cucumber Architecture","doc":"```\nFeature File → Parser → AST\n                          ↓\nStep Files → Discovery → Registry\n                          ↓\n                      Compiler → Test Modules\n                                      ↓\n                                  ExUnit → Results\n```","ref":"architecture.html#data-flow"},{"type":"extras","title":"Key Design Decisions - Cucumber Architecture","doc":"","ref":"architecture.html#key-design-decisions"},{"type":"extras","title":"Auto-Discovery - Cucumber Architecture","doc":"- Features and steps are automatically discovered\n- No need to explicitly wire features to test modules\n- Follows Ruby Cucumber's convention-over-configuration approach","ref":"architecture.html#auto-discovery"},{"type":"extras","title":"ExUnit Integration - Cucumber Architecture","doc":"- Generated tests are standard ExUnit test modules\n- Full support for ExUnit features (tags, setup, async)\n- Works with existing test tooling","ref":"architecture.html#exunit-integration"},{"type":"extras","title":"Runtime Compilation - Cucumber Architecture","doc":"- Tests are generated at runtime when `mix test` runs\n- Allows for dynamic test generation\n- No generated files to manage","ref":"architecture.html#runtime-compilation"},{"type":"extras","title":"Context Management - Cucumber Architecture","doc":"- ExUnit context is used directly\n- Background steps modify context in setup\n- Each step can read and modify context","ref":"architecture.html#context-management"},{"type":"extras","title":"Error Handling - Cucumber Architecture","doc":"Cucumber provides detailed error messages for common issues:\n\n1. **Undefined Steps**: Shows the exact step text and suggests implementation\n2. **Step Failures**: Shows the error, step location, and execution history\n3. **Duplicate Steps**: Detected at load time with file/line information","ref":"architecture.html#error-handling"},{"type":"extras","title":"Extensibility - Cucumber Architecture","doc":"The architecture supports several extension points:\n\n1. **Custom Parameter Types**: Add new parameter types to Expression\n2. **Custom Formatters**: Create custom output formats\n3. **Hooks**: Before/after scenario hooks (via ExUnit setup/teardown)\n4. **Step Libraries**: Create reusable step definition modules","ref":"architecture.html#extensibility"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.1"}}